// TSMLSet.cpp : implementation of the CTSMLSet class
//

#include "stdafx.h"
#include "TSML.h"
#include "TSMLSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTSMLSet implementation

IMPLEMENT_DYNAMIC(CTSMLSet, CRecordset)

CTSMLSet::CTSMLSet(CDatabase* pdb)
	: CRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CTSMLSet)
	m_ID = 0;
	m_column1 = 0;
	m_column2 = _T("");
	m_column3 = _T("");
	m_ISBN = _T("");
	m_column4 = 0;
	m_column5 = 0;
	m_column6 = 0;
	m_column7 = 0;
	m_column8 = FALSE;
	m_column9 = 0;
	m_column10 = _T("");
	m_column11 = _T("");
	m_column12 = FALSE;
	m_column13 = _T("");
	m_column14 = 0;
	m_column15 = _T("");
	m_column16 = 0;
	m_column17 = _T("");
	m_nFields = 19;
	//}}AFX_FIELD_INIT
	m_nDefaultType = snapshot;
}

CString CTSMLSet::GetDefaultConnect()
{
//	return _T("ODBC;DSN=Book");
	return "";
}

CString CTSMLSet::GetDefaultSQL()
{
//	return _T("[Ŀ¼]");
	return "";
}

void CTSMLSet::DoFieldExchange(CFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CTSMLSet)
	pFX->SetFieldType(CFieldExchange::outputColumn);
	RFX_Long(pFX, _T("[ID]"), m_ID);
	RFX_Long(pFX, _T("[ˮ]"), m_column1);
	RFX_Text(pFX, _T("[]"), m_column2);
	RFX_Text(pFX, _T("[ͼ]"), m_column3);
	RFX_Text(pFX, _T("[ISBN]"), m_ISBN);
	RFX_Date(pFX, _T("[ʱ]"), m_column4);
	RFX_Int(pFX, _T("[]"), m_column5);
	RFX_Long(pFX, _T("[]"), m_column6);
	RFX_Long(pFX, _T("[ڼ]"), m_column7);
	RFX_Bool(pFX, _T("[Ƿע]"), m_column8);
	RFX_Date(pFX, _T("[עʱ]"), m_column9);
	RFX_Text(pFX, _T("[Ҫ]"), m_column10);
	RFX_Text(pFX, _T("[ͼҷ]"), m_column11);
	RFX_Bool(pFX, _T("[Ƿ¹]"), m_column12);
	RFX_Text(pFX, _T("[]"), m_column13);
	RFX_Date(pFX, _T("[ʱ]"), m_column14);
	RFX_Text(pFX, _T("[ԭ]"), m_column15);
	RFX_Long(pFX, _T("[ͼ˳]"), m_column16);
	RFX_Text(pFX, _T("[]"), m_column17);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CTSMLSet diagnostics

#ifdef _DEBUG
void CTSMLSet::AssertValid() const
{
	CRecordset::AssertValid();
}

void CTSMLSet::Dump(CDumpContext& dc) const
{
	CRecordset::Dump(dc);
}
#endif //_DEBUG
